LocalizationManager:add_localized_strings( {
    ["charging_melee"] = "Charging",
    ["charged_melee"] = "Charged!",
} )

Hooks:PostHook(PlayerStandard, "_start_action_melee", "MeleeChargeTimerStart", function(self, t, input, instant)
	if not instant then
		local melee_entry = managers.blackmarket:equipped_melee_weapon()
		local max_charge_time = tweak_data.blackmarket.melee_weapons[melee_entry].stats.charge_time

		local melee_name = managers.localization:text(tweak_data.blackmarket.melee_weapons[melee_entry].name_id or "")
		local melee_charge = managers.localization:text("charging_melee")

		managers.hud:show_progress_timer_bar(0, max_charge_time)
		managers.hud:show_progress_timer({text = ( melee_charge .. " " .. melee_name .. "..." )})
	end
end )

Hooks:PostHook(PlayerStandard, "_do_action_melee", "MeleeChargeTimerInterupt", function(self, t, input, skip_damage)
	local melee_entry = managers.blackmarket:equipped_melee_weapon()
	local instant = tweak_data.blackmarket.melee_weapons[melee_entry].instant

	if not instant then
		local max_charge_time = tweak_data.blackmarket.melee_weapons[melee_entry].stats.charge_time
		local cur_charge_time = self:_get_melee_charge_lerp_value(t) * max_charge_time

		if cur_charge_time >= max_charge_time then
			managers.hud:hide_progress_timer_bar(true)
		else
			managers.hud:hide_progress_timer_bar(false)
		end

		managers.hud:remove_progress_timer()
	end
end )

Hooks:PostHook(PlayerStandard, "_update_melee_timers", "MeleeChargeTimerUpdate", function(self, t, input)
	if self._state_data.meleeing then
		local melee_entry = managers.blackmarket:equipped_melee_weapon()
		local instant = tweak_data.blackmarket.melee_weapons[melee_entry].instant

		if not instant then
			local max_charge_time = tweak_data.blackmarket.melee_weapons[melee_entry].stats.charge_time
			local cur_charge_time = self:_get_melee_charge_lerp_value(t) * max_charge_time

			if cur_charge_time >= max_charge_time then
				managers.hud:set_progress_timer_bar_valid(false, "charged_melee")
			else
				managers.hud:set_progress_timer_bar_valid(true, nil)
			end
			
			managers.hud:set_progress_timer_bar_width(cur_charge_time, max_charge_time)
		end
	end
end )
